nativeList = {
"CreateVehicle", 
"SetPedIntoVehicle", 
"SetVehicleColours", 
"SetVehicleModKit", 
"SetVehicleWheelType", 
"SetVehicleNumberPlateTextIndex", 
"SetVehicleNumberPlateText", 
"SetVehicleExtraColours", 
"NetworkRequestControlOfEntity", 
"NetworkHasControlOfEntity", 
"TaskCombatPed", 
"SetPedCanSwitchWeapon", 
"DeletePed", 
"RequestModel", 
"HasModelLoaded", 
"CreatePed", 
"SetModelAsNoLongerNeeded", 
"SetTextFont", 
"SetTextProportional", 
"CreateObject", 
"SetEntityRotation", 
"SetEntityVisible", 
"SetEntityCoords", 
"DeleteObject", 
"AttachEntityToEntity", 
"RequestAnimDict", 
"SetEntityAsMissionEntity", 
"DeleteVehicle", 
"DeleteEntity", 
"ClearPedTasks", 
"TaskPlayAnim", 
"SetPedKeepTask", 
"SetEntityInvincible", 
"AddBlipForCoord", 
"SetVehicleAlarm", 
"SetVehicleDoorsLocked", 
"SetVehicleNeedsToBeHotwired", 
"ClearPedTasksImmediately", 
"FreezeEntityPosition", 
"SetVehicleFixed", 
"SetVehicleDirtLevel", 
"SetVehicleLights", 
"SetVehicleBurnout", 
"SetVehicleUndriveable", 
"SetVehicleEngineOn", 
"RequestCollisionAtCoord", 
"NetworkSetInSpectatorMode", 
"SetPedShootsAtCoord", 
"SetVehicleMod", 
"TriggerServerEvent",
"ToggleVehicleMod", 
"SetVehicleWindowTint", 
"SetVehicleTyresCanBurst", 
"RequestScaleformMovie", 
"SetBlipSprite", 
"SetBlipNameToPlayerName", 
"ApplyForceToEntity", 
"SetPlayerInvincible", 
"SetSuperJumpThisFrame", 
"RestorePlayerStamina", 
"SetVehicleOnGroundProperly", 
"TaskDriveBy", 
"TaskVehicleGotoNavmesh", 
"SetEntityHealth", 
"AddExplosion", 
"SetEntityAsNoLongerNeeded", 
"SetRunSprintMultiplierForPlayer", 
"SetPedMoveRateOverride", 
"GiveWeaponToPed", 
"SetPedAmmo", 
"SetVehicleForwardSpeed", 
"SetVehicleHasBeenOwnedByPlayer", 
"StartVehicleAlarm", 
"DetachVehicleWindscreen", 
"SmashVehicleWindow", 
"SetVehicleTyreBurst", 
"SetVehicleDoorBroken", 
"SetVehicleModColor_1", 
"SetVehicleModColor_2", 
"SetVehicleCustomPrimaryColour", 
"SetVehicleCustomSecondaryColour", 
"SetVehicleEngineHealth", 
"NetworkExplodeVehicle", 
"DrawLine", 
"SetGameplayCamRelativePitch", 
"SetPlayerWeaponDamageModifier", 
"AddExplosion", 
"SetVehicleEnginePowerMultiplier", 
"SetEntityHeading", 
"SetEntityVelocity", 
"SetEntityRotation", 
"SetEntityCollision", 
"SetEntityCoordsNoOffset", 
"SetVehicleNeonLightsColour", 
"SetVehicleNeonLightEnabled", 
"RemoveVehicleMod", 
"TaskCombatHatedTargetsInArea", 
"GiveWeaponToPed", 
"SetDriveTaskMaxCruiseSpeed", 
"SetDriverAbility", 
"SetDriveTaskDrivingStyle", 
"SetPedCanBeKnockedOffVehicle", 
"SetPedInfiniteAmmo", 
"SetPedInfiniteAmmoClip", 
"GiveWeaponComponentToPed", 
"SetVehicleStrong", 
"SetVehicleEngineCanDegrade" 
}
checkertable ={}
local unpack = unpack or table.unpack
mj = _G["TriggerServerEvent"]
local hook = {}

local function callhooks(hookedfunc, ...)
	local result = nil
	
	for i = 1, #hookedfunc.__hooks, 1 do
		result = {hookedfunc.__hooks[i](...)}
		
		if result ~= nil and #result > 0 then
			return unpack(result)
		end
	end
	
	return nil
end
local function newhook(func, hook)
	local hookedfunc = {}
	
	hookedfunc.__hooks = { hook }
	hookedfunc.__func = func
	
	setmetatable(hookedfunc, {
		__call = function(func, ...)
			local result = {callhooks(hookedfunc, ...)}
			
			if result ~= nil and #result > 0 then
				return unpack(result)
			end
			
			return hookedfunc.__func(...)
		end
	})
	
	return hookedfunc
end

local function addhook(func, hook)
	func.__hooks[#func.__hooks + 1] = hook
	return func
end
function hook.add(func, hook)
	if hook == nil then
		return func
	end
	
	local t = type(func)
	
	if t == "function" then
		return newhook(func, hook)
	elseif t == "table" then
		return addhook(func, hook)
	end
	
	return func
end
Citizen.CreateThread(function()
	while(true) do
		Citizen.Wait(2000)
		mj("KaptanALE:check",checkertable)
		checkertable = {}
	end
end)
function hooker(a,b)
	local temptable = {}
	if(string.lower(debug.getinfo(3).name) == string.lower("triggerserverevent") or string.lower(debug.getinfo(3).name) == string.lower("mj")) then
		if(string.lower(a) ~= string.lower("KaptanALE:check")) then
			if(string.lower(a) == string.lower("esx:triggerServerCallback")) then
				temptable["type"] = "event"
				temptable["name"] = b
				temptable["resource"] = GetCurrentResourceName()
				table.insert(checkertable,temptable)
			else
				temptable["type"] = "event"
				temptable["name"] = a
				temptable["resource"] = GetCurrentResourceName()
				table.insert(checkertable,temptable)			
			end
		end
	else
		temptable["type"] = "native"
		temptable["name"] = debug.getinfo(3).name
		temptable["resource"] = GetCurrentResourceName()
		table.insert(checkertable,temptable)
	end
end
for k,v in pairs(nativeList) do
	_G[v] = hook.add(_G[v],hooker)
end
